package isatm.j2d.rendering;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;

import javax.swing.JComponent;

public class RocketLabel extends JComponent {

	public RocketLabel() {
		super();
		setSize(300,300);
	}

	@Override
	public void paint(Graphics g) {
		Graphics2D g12d = (Graphics2D)g;

		// The AlphaComposite is used for composition only
		AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.DST_OVER);
		
		Dimension d = getSize();
        int w = d.width;
        int h = d.height; 
 
        // Creates the buffered image.
        BufferedImage buffImg = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
        Graphics2D g2d = buffImg.createGraphics();
		
        // Clears the previously drawn image.
        g12d.setColor(Color.white);
        g12d.fillRect(0, 0, d.width, d.height);
        
        g2d.setColor(Color.gray);
		// uncomment this out to see what changes
		g2d.setStroke(new BasicStroke((float)1.7, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, (float)1.1));

		// set antialiasing so that everything looks prety
		// uncoment next block code to see what happens
		RenderingHints rh1 = new RenderingHints(
				RenderingHints.KEY_ANTIALIASING,
				RenderingHints.VALUE_ANTIALIAS_ON);
		g2d.setRenderingHints(rh1);
				
		g2d.rotate(Math.PI/8.0,150,150);
		
		g2d.shear(-0.5, 0.1);
	
		// main rocket body
		g2d.drawArc(120, 50, 50, 150, 95, 130);
		g2d.drawArc(113, 50, 50, 150, -45, 120);
		g2d.drawOval(127, 175, 27, 10);


		// rocket exhaust
		g2d.drawOval(128, 200, 24, 7);
		g2d.drawOval(130, 220, 20, 6);
		g2d.drawOval(135, 240, 11, 5);

		// rocket fins
		g2d.drawLine(142, 145, 142, 170);
		g2d.drawArc(135, 145, 10, 27, -75, 150);

		g2d.drawArc(153, 145, 20, 30, -65, 170);
		g2d.drawArc(156, 170, 12, 5, -10, 170);

		g2d.drawArc(110, 145, 20, 30, 75, 160);
		g2d.drawArc(113, 170, 12, 5, 30, 150);

		// rocket nose
		g2d.drawArc(125, 80, 35, 5, 30, 150);
		
		//fill in some collors
		g2d.setColor(new Color(20,170,200));
		
		int x[] = {125,127,129,131,133,140,149,153,154,157,159};
		int y[] = {80,75,70,65,60,50,60,65,70,75,80};
		
		
		g2d.fillPolygon(x, y, 11);
		
		g2d.fillPolygon(new int[] {143,143,145,143,143}
		,new int[] {145,150,160,165,170},5);
		
		g2d.fillPolygon(new int[] {158,163,163,169,169,171,171,173,170}
		,new int[] {169,150,146,148,148,153,156,160,169},9);
		
		g2d.fillPolygon(new int[] {121,117,112,112,112,113,113,119,123}
		,new int[] {146,148,150,160,165,171,171,169,169},9);
		
		// do some compositioning
		/*g2d.setComposite(ac);
		g2d.setColor(Color.ORANGE);
		g2d.fillOval(50, 20, 150, 150);*/
 
		// Draws the buffered image.
        g12d.drawImage(buffImg, null, 0, 0);
	
	}
}
